/* The basic queue routines. */

#include "code.h"

void initialize(queue *q)
{
    q -> v = (data *)malloc(sizeof(data) * FULL);
    q -> cnt = 0;
    q -> front = MAX_IND;
    q -> rear = 0;
}

data dequeue(queue *q)
{ 
    int i = q -> front;
 
    q -> front = (i + FULL - 1) % FULL;
    q -> cnt--;
    return q -> v[i];
}

void enqueue(data d, queue *q)
{
    int i = (q -> rear + FULL - 1) % FULL;
 
    q -> v[i] = d;
    q -> rear = i;
    q -> cnt++;
}

data front(const queue *q)
{
   return (q -> v[q -> front]);
}

boolean empty(const queue *q)
{
   return ((boolean) (q -> cnt == EMPTY));
}

boolean full(const queue *q)
{
   return ((boolean) (q -> cnt == FULL));
}
